#pragma once
#include "state.h"

class StateSalad : public State {
    StateSalad(void);
    ~StateSalad(void) {}
public:
    static StateSalad* getInstance() {
        static StateSalad p;
        return &p;
    }
    void initialize();
    void draw();
    std::string message() { return "Salad mode"; }
    void OnLButtonDown(UINT nFlags, CPoint& point);
    void OnLButtonUp  (UINT nFlags, CPoint& point);
    void OnRButtonDown(UINT nFlags, CPoint& point);
    void OnRButtonUp  (UINT nFlags, CPoint& point);
    void OnMouseMove  (UINT nFlags, CPoint& point);
    void OnKeyDown    (UINT nChar, UINT nRepCnt, UINT nFlags);
    void OnDropFiles  (const std::string& fname, const std::string& ext);

    bool showSilhouette_;
    bool showNoise_;
    int  showFaceEdge_;      // 0: nothing, 1: face, 2: edge, 3: face&edge
    bool onDrawCompute_;
    int currentPieceID_;
    CPoint pointOld_;
};
